import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { CmsSpec, CmsSpecParam } from './model';


/**
 * 分页查询规格
 */
export async function pageCmsSpec(params: CmsSpecParam) {
  const res = await request.get<ApiResult<PageResult<CmsSpec>>>(
    '/cms/cms-spec/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询规格列表
 */
export async function listCmsSpec(params?: CmsSpecParam) {
  const res = await request.get<ApiResult<CmsSpec[]>>(
    '/cms/cms-spec',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加规格
 */
export async function addCmsSpec(data: CmsSpec) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-spec',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改规格
 */
export async function updateCmsSpec(data: CmsSpec) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-spec',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除规格
 */
export async function removeCmsSpec(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-spec/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除规格
 */
export async function removeBatchCmsSpec(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-spec/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询规格
 */
export async function getCmsSpec(id: number) {
  const res = await request.get<ApiResult<CmsSpec>>(
    '/cms/cms-spec/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
